package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class JoinCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (player != null) {
            if (args.length <= 1) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" + BlockHunt.CMDJoin.usage);
            } else {
                ArenaHandler.playerJoinArena(player, args[1]);
            }
        } else {
            MessageManager.sendFMessage(null, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }
}
