package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.config.ConfigKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class ListCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        MessageManager.sendFMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-" + BlockHunt.getPluginDescriptionFile().getName());
        if (MemoryStorage.arenaList.size() >= 1) {
            MessageManager.sendMessage(player, "&7Available arena(s):");
            for (Arena arena : MemoryStorage.arenaList) {
                MessageManager.sendMessage(player, "%A" + arena.arenaName);
            }
        } else {
            MessageManager.sendMessage(player, "&7&oNo arenas available...");
            MessageManager.sendMessage(player, "&7&oCreate an arena first please.");
        }
        MessageManager.sendFMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-&oArenas list");
        return true;
    }
}
