package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.ConfigManager;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class ReloadCommand extends DefaultCommand {


    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        ConfigManager.newFiles();

        MemoryStorage.config.load();
        MemoryStorage.messages.load();
        MemoryStorage.arenas.load();
        MemoryStorage.signs.load();
        MemoryStorage.shop.load();
        for (Arena arena : MemoryStorage.arenaList) {
            String cause = "[BlockHunt] Arena " + arena.arenaName + " has been stopped";
            ArenaHandler.stopArena(arena, cause, MessageKey.WARNING_ARENA_STOPPED);
        }

        ArenaHandler.loadArenas();
        MessageManager.sendFMessage(player, MessageKey.NORMAL_RELOADED_CONFIGS);
        return true;
    }
}
