package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.InventoryHandler;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class SetCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (player != null) {
            if (args.length <= 1) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" + BlockHunt.CMDSet.usage);
            } else {
                String arenaName = args[1];
                InventoryHandler.openPanel(player, arenaName);
            }
        } else {
            MessageManager.sendFMessage(player, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }
}
