package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.arena.ArenaHandler;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class SetWarpCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (player != null) {
            if (args.length <= 2) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" + BlockHunt.CMDSetWarp.usage);
            } else {
                String arenaName = args[2];
                String warpname = args[1];

                Arena arena = null;
                for (Arena arena2 : MemoryStorage.arenaList) {
                    if (arena2.arenaName.equalsIgnoreCase(arenaName)) {
                        arena = arena2;
                    }
                }
                if (arena != null) {
                    Location loc = player.getLocation();
                    if (warpname.equalsIgnoreCase("lobby")) {
                        arena.lobbyWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("hiders")) {
                        arena.hidersWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("seekers")) {
                        arena.seekersWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpname);
                    } else if (warpname.equalsIgnoreCase("spawn")) {
                        arena.spawnWarp = loc;
                        save(arena);
                        MessageManager.sendFMessage(player, MessageKey.NORMAL_SET_WARP_WARP_SET, "warp-" + warpname);
                    } else {
                        MessageManager.sendFMessage(player, MessageKey.ERROR_SET_WARP_WARP_NOT_FOUND, "warp-" + warpname);
                    }
                } else {
                    MessageManager.sendFMessage(player, MessageKey.ERROR_NO_ARENA, "name-" + arenaName);
                }
            }
        } else {
            MessageManager.sendFMessage(null, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }

    public void save(Arena arena) {
        MemoryStorage.arenas.getFile().set(arena.arenaName, arena);
        MemoryStorage.arenas.save();
        ArenaHandler.loadArenas();
    }
}
