package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;

public class TokensCommand extends DefaultCommand {


    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (args.length <= 3) {
            MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" + BlockHunt.CMDTokens.usage);
        } else {
            String option = args[1];
            String playerName = args[2];
            int amount;
            try {
                amount = Integer.parseInt(args[3]);
            } catch (NumberFormatException e) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_NOT_A_NUMBER, "1-" + args[3]);
                return true;
            }

            Player tokenPlayer = Bukkit.getPlayer(playerName);
            if (tokenPlayer == null) {
                MessageManager.sendFMessage(player, MessageKey.ERROR_TOKENS_PLAYER_NOT_ONLINE, "%playerName%-" + playerName);
                return true;
            }
            String name = "\u00A78Console";
            if (player != null) {
                name = player.getName();
            }

            if (option.equalsIgnoreCase("set")) {
                MemoryStorage.shop.getFile().set(tokenPlayer.getName() + ".tokens", amount);
                MemoryStorage.shop.save();
                MessageManager.sendFMessage(player, MessageKey.NORMAL_TOKENS_CHANGED, "option-Set", "%playerName%-" + tokenPlayer.getName(), "option2-to", "amount-" + amount);
                MessageManager.sendFMessage(tokenPlayer, MessageKey.NORMAL_TOKENS_CHANGED_PERSON, "option-set", "%playerName%-" + name, "option2-to", "amount-" + amount);
            } else if (option.equalsIgnoreCase("add")) {
                int tokens = 0;
                if (MemoryStorage.shop.getFile().getInt(tokenPlayer.getName() + ".tokens") != 0) {
                    tokens = MemoryStorage.shop.getFile().getInt(tokenPlayer.getName() + ".tokens");
                }
                MemoryStorage.shop.getFile().set(tokenPlayer.getName() + ".tokens", tokens + amount);
                MemoryStorage.shop.save();
                MessageManager.sendFMessage(player, MessageKey.NORMAL_TOKENS_CHANGED, "option-Added", "%playerName%-" + tokenPlayer.getName(), "option2-to", "amount-" + amount);
                MessageManager.sendFMessage(tokenPlayer, MessageKey.NORMAL_TOKENS_CHANGED_PERSON, "option-added", "%playerName%-" + name, "option2-to", "amount-" + amount);
            } else if (option.equalsIgnoreCase("take")) {
                int tokens = 0;
                if (MemoryStorage.shop.getFile().getInt(tokenPlayer.getName() + ".tokens") != 0) {
                    tokens = MemoryStorage.shop.getFile().getInt(tokenPlayer.getName() + ".tokens");
                }
                MemoryStorage.shop.getFile().set(tokenPlayer.getName() + ".tokens", tokens - amount);
                MemoryStorage.shop.save();
                MessageManager.sendFMessage(player, MessageKey.NORMAL_TOKENS_CHANGED, "option-Took", "%playerName%-" + tokenPlayer.getName(), "option2-from", "amount-" + amount);
                MessageManager.sendFMessage(tokenPlayer, MessageKey.NORMAL_TOKENS_CHANGED_PERSON, "option-took", "%playerName%-" + name, "option2-from", "amount-" + amount);
            } else {
                MessageManager.sendFMessage(player, MessageKey.ERROR_TOKENS_UNKNOWN_SETTING, "option-" + option);
            }
        }
        return true;
    }
}
