package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.config.ConfigKey;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.MessageManager;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class WandCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, Command cmd, String label, String[] args) {
        if (player != null) {
            ItemStack wand = new ItemStack(Material.getMaterial((String) MemoryStorage.config.get(ConfigKey.WAND_ID_NAME)));
            ItemMeta im = wand.getItemMeta();
            im.setDisplayName(MessageManager.replaceAll((String) MemoryStorage.config.get(ConfigKey.WAND_NAME)));
            MemoryStorage.config.load();
            List<String> loreLines = MemoryStorage.config.getFile().getStringList(ConfigKey.WAND_DESCRIPTION.getPath());
            List<String> loreLines2 = new ArrayList<>();
            for (String lore : loreLines) {
                loreLines2.add(MessageManager.replaceAll(lore));
            }

            im.setLore(loreLines2);
            wand.setItemMeta(im);
            player.getInventory().addItem(wand);
            player.playSound(player.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 5, 0);
            MessageManager.sendFMessage(player, MessageKey.NORMAL_WAND_GAVE_WAND, "type-" + wand.getType().toString().replaceAll("_", " ").toLowerCase());
        } else {
            MessageManager.sendFMessage(null, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }
}
