package net.knarcraft.blockhunt.config;

import net.knarcraft.blockhunt.manager.ConfigManager;

/**
 * A key pointing to some configuration value
 */
public interface Key {

    /**
     * Gets the path to this key's value
     *
     * @return <p>This key's path</p>
     */
    String getPath();

    /**
     * The config manager managing this key
     *
     * @return <p>This key's config manager</p>
     */
    ConfigManager getConfigManager();

    /**
     * Gets the default value of this configuration key
     *
     * @return <p>The default value</p>
     */
    Object getDefaultValue();

}
