package net.knarcraft.blockhunt.config;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.manager.ConfigManager;

/**
 * A key pointing to a value in messages.properties
 */
public enum MessageKey implements Key {

    LOG_ENABLED_PLUGIN("%TAG%N%name%&a&k + %N%version% is now Enabled. Made by %A%authors%%N.",
            "log.enabledPlugin"),
    LOG_DISABLED_PLUGIN("%TAG%N%name%&c&k - %N%version% is now Disabled. Made by %A%authors%%N.",
            "log.disabledPlugin"),

    HELP_INFO("%NDisplays the plugin's info.", "help.info"),
    HELP_HELP("%NShows a list of commands.", "help.help"),
    HELP_RELOAD("%NReloads all configs.", "help.reload"),
    HELP_JOIN("%NJoins a " + BlockHunt.getPluginDescriptionFile().getName() + " game.", "help.join"),
    HELP_LEAVE("%NLeave a " + BlockHunt.getPluginDescriptionFile().getName() + " game.", "help.leave"),
    HELP_LIST("%NShows a list of available arenas.", "help.list"),
    HELP_SHOP("%NOpens the " + BlockHunt.getPluginDescriptionFile().getName() + " shop.", "help.shop"),
    HELP_START("%NForces an arena to start.", "help.start"),
    HELP_WAND("%NGives you the wand selection tool.", "help.wand"),
    HELP_CREATE("%NCreates an arena from your selection.", "help.create"),
    HELP_SET("%NOpens a panel to set settings.", "help.set"),
    HELP_SET_WARP("%NSets warps for your arena.", "help.setWarp"),
    HELP_REMOVE("%NDeletes an Arena.", "help.remove"),
    HELP_TOKENS("%NChange someones tokens.", "help.tokens"),

    BUTTON_ADD("%NAdd %A%1%%N to %A%2%%N", "button.add"),
    BUTTON_ADD_2("Add", "button.add2"),
    BUTTON_SETTING("%NSetting %A%1%%N is now: %A%2%%N.", "button.setting"),
    BUTTON_REMOVE("%NRemove %A%1%%N from %A%2%%N", "button.remove"),
    BUTTON_REMOVE_2("Remove", "button.remove2"),

    NORMAL_RELOADED_CONFIGS("%TAG&aReloaded all configs!", "normal.reloadedConfigs"),
    NORMAL_JOIN_JOINED_ARENA("%TAG%A%%playerName%%%N joined your arena. (%A%1%%N/%A%2%%N)",
            "normal.joinJoinedArena"),
    NORMAL_LEAVE_YOU_LEFT("%TAG%NYou left the arena! Thanks for playing!", "normal.leaveYouLeft"),
    NORMAL_LEAVE_LEFT_ARENA("%TAG%A%%playerName%%%N left your arena. (%A%1%%N/%A%2%%N)",
            "normal.leaveLeftArena"),
    NORMAL_START_FORCED("%TAG%NYou forced to start arena '%A%arenaName%%N'!", "normal.startForced"),
    NORMAL_WAND_GAVE_WAND("%TAG%NHere you go! &o(Use the %A&o%type%%N&o!)", "normal.wandGaveWand"),
    NORMAL_WAND_SET_POSITION("%TAG%NSet position %A#%number%%N to location: (%A%x%%N, %A%y%%N, %A%z%%N).",
            "normal.wandSetPosition"),
    NORMAL_CREATE_CREATED_ARENA("%TAG%NCreated an arena with the name '%A%name%%N'.",
            "normal.createCreatedArena"),
    NORMAL_LOBBY_ARENA_IS_STARTING("%TAG%NThe arena will start in %A%1%%N second(s)!",
            "normal.lobbyArenaIsStarting"),
    NORMAL_LOBBY_ARENA_STARTED("%TAG%NThe arena has been started! The seeker is coming to find you in " +
            "%A%secs%%N seconds!", "normal.lobbyArenaStarted"),
    NORMAL_IN_GAME_SEEKER_CHOSEN("%TAG%NPlayer %A%seeker%%N has been chosen as seeker!",
            "normal.inGameSeekerChosen"),
    NORMAL_IN_GAME_BLOCK("%TAG%NYou're disguised as a(n) '%A%block%%N' block.", "normal.inGameBlock"),
    NORMAL_IN_GAME_ARENA_END("%TAG%NThe arena will end in %A%1%%N second(s)!", "normal.inGameArenaEnd"),
    NORMAL_IN_GAME_SEEKER_SPAWNED("%TAG%A%%playerName%%%N has spawned as a seeker!",
            "normal.inGameSeekerSpawned"),
    NORMAL_IN_GAME_GIVEN_SWORD("%TAG%NYou were given a sword!", "normal.inGameGivenSword"),
    NORMAL_IN_GAME_HIDER_DIED("%TAG%NHider %A%%playerName%%%N was killed by %A%killer%%N!",
            "normal.inGameHiderDied"),
    NORMAL_IN_GAME_HIDERS_LEFT("%NHider(s) left: %A%left%%N", "normal.inGameHidersLeft"),
    NORMAL_IN_GAME_SEEKER_DIED("%TAG%NSeeker %A%%playerName%%%N died and will respawn in %A%secs%%N" +
            "seconds!", "normal.inGameSeekerDied"),
    normal_winSeekers("%TAG%NThe %ASEEKERS%N have won!", "normal.winSeekers"),
    NORMAL_WIN_HIDERS("%TAG%NThe %AHIDERS%N have won!", "normal.winHiders"),
    NORMAL_SET_WARP_WARP_SET("%TAG%NSet warp '%A%warp%%N' to your location!", "normal.setWarpWarpSet"),
    NORMAL_ADDED_TOKEN("%TAG%A%amount%%N tokens were added to your account!", "normal.addedToken"),
    NORMAL_REMOVE_REMOVED_ARENA("%TAG%NRemoved arena '%A%name%%N'!", "normal.removeRemovedArena"),
    NORMAL_TOKENS_CHANGED("%TAG%N%option% %A%amount%%N tokens %option2% %A%%playerName%%%N.",
            "normal.tokensChanged"),
    NORMAL_TOKENS_CHANGED_PERSON("%TAG%NPlayer %A%%playerName%%%N %N%option% %A%amount%%N %option2% your " +
            "tokens.", "normal.tokensChangedPerson"),
    NORMAL_IN_GAME_NOW_SOLID("%TAG%NYou're now a solid '%A%block%%N' block!", "normal.inGameNowSolid"),
    NORMAL_IN_GAME_NO_MORE_SOLID("%TAG%NYou're no longer a solid block!", "normal.inGameNoMoreSolid"),
    NORMAL_SHOP_BOUGHT_ITEM("%TAG%NYou've bought the '%A%itemName%%N' item!", "normal.shopBoughtItem"),
    NORMAL_SHOP_CHOSEN_BLOCK("%TAG%NYou've chosen to be a(n) '%A%block%%N' block!",
            "normal.shopChosenBlock"),
    NORMAL_SHOP_CHOSEN_SEEKER("%TAG%NYou've chosen to be a %Aseeker%N!", "normal.shopChosenSeeker"),
    NORMAL_SHOP_CHOSEN_HIDERS("%TAG%NYou've chosen to be a %Ahider%N!", "normal.shopChosenHiders"),
    NORMAL_IN_GAME_BLOCKS_LEFT("%TAG%NRemaining blocks: %A%1%%N", "normal.inGameBlocksLeft"),

    WARNING_LOBBY_NEED_AT_LEAST("%TAG%WYou need at least %A%1% player(s) to start the game!",
            "warning.lobbyNeedAtLeast"),
    WARNING_IN_GAME_NEW_SEEKER_CHOSEN("%TAG%WThe last seeker left and a new seeker has been chosen!",
            "warning.inGameNewSeekerChosen"),
    WARNING_UNABLE_TO_COMMAND("%TAG%WSorry but that command is disabled in the arena.",
            "warning.unableToCommand"),
    WARNING_IN_GAME_NO_SOLID_PLACE("%TAG%WThat's not a valid place to become solid!",
            "warning.inGameNoSolidPlace"),
    WARNING_ARENA_STOPPED("%TAG%WThe arena has been forced to stop!", "warning.arenaStopped"),

    ERROR_NO_PERMISSION("%TAG%EYou don't have the permissions to do that!", "error.noPermission"),
    ERROR_NOT_A_NUMBER("%TAG%E'%A%1%%E' is not a number!", "error.notANumber"),
    ERROR_COMMAND_NOT_ENABLED("%TAG%EThis command has been disabled!", "error.commandNotEnabled"),
    ERROR_COMMAND_NOT_FOUND("%TAG%ECouldn't find the command. Try %A/" + BlockHunt.getPluginDescriptionFile().getName() +
            " help %Efor more info.", "error.commandNotFound"),
    ERROR_NOT_ENOUGH_ARGUMENTS("%TAG%EYou're missing arguments, correct syntax: %A%syntax%",
            "error.notEnoughArguments"),
    ERROR_LIBS_DISGUISES_NOT_INSTALLED("%TAG%EThe plugin '%ALib's Disguises%E' is required to run this " +
            "plugin! Install it or it won't work!", "error.libsDisguisesNotInstalled"),
    ERROR_PROTOCOL_LIB_NOT_INSTALLED("%TAG%EThe plugin '%AProtocolLib%E' is required to run this plugin!" +
            " Install it or it won't work!", "error.protocolLibNotInstalled"),
    ERROR_NO_ARENA("%TAG%ENo arena found with the name '%A%name%%E'.", "error.noArena"),
    ERROR_ONLY_IN_GAME("%TAG%EThis is an only in-game command!", "error.onlyInGame"),
    ERROR_JOIN_ALREADY_JOINED("%TAG%EYou've already joined an arena!", "error.joinAlreadyJoined"),
    ERROR_JOIN_NO_BLOCKS_SET("%TAG%EThere are no blocks set for this arena. Notify the administrator.",
            "error.joinNoBlocksSet"),
    ERROR_JOIN_WARPS_NOT_SET("%TAG%EThere are no warps set for this arena. Notify the administrator.",
            "error.joinWarpsNotSet"),
    ERROR_JOIN_ARENA_IN_GAME("%TAG%EThis game has already started.", "error.joinArenaInGame"),
    ERROR_JOIN_FULL("%TAG%EUnable to join this arena. It's full!", "error.joinFull"),
    ERROR_JOIN_INVENTORY_NOT_EMPTY("%TAG%EYour inventory should be empty before joining!",
            "error.joinInventoryNotEmpty"),
    ERROR_LEAVE_NOT_IN_ARENA("%TAG%EYou're not in an arena!", "error.leaveNotInArena"),
    ERROR_CREATE_SELECTION_FIRST("%TAG%EMake a selection first. Use the wand command: %A/" +
            BlockHunt.getPluginDescriptionFile().getName() + " <wand|w>%E.", "error.createSelectionFirst"),
    ERROR_CREATE_NOT_SAME_WORLD("%TAG%EMake your selection points in the same world!",
            "error.createNotSameWorld"),
    ERROR_SET_TOO_HIGH_NUMBER("%TAG%EThat amount is too high! Max amount is: %A%max%%E.",
            "error.setTooHighNumber"),
    ERROR_SET_TOO_LOW_NUMBER("%TAG%EThat amount is too low! Minimal amount is: %A%min%%E.",
            "error.setTooLowNumber"),
    ERROR_SET_NOT_A_BLOCK("%TAG%EThat is not a block!", "error.setNotABlock"),
    ERROR_SET_WARP_WARP_NOT_FOUND("%TAG%EWarp '%A%warp%%E' is not valid!", "error_setWarpWarpNotFound"),
    ERROR_TOKENS_PLAYER_NOT_ONLINE("%TAG%ENo player found with the name '%A%%playerName%%%E'!",
            "error.tokensPlayerNotOnline"),
    ERROR_TOKENS_UNKNOWN_SETTING("%TAG%E'%A%option%%E' is not a known option!",
            "error.tokensUnknownSetting"),
    ERROR_SHOP_NEED_MORE_TOKENS("%TAG%EYou need more tokens before you can buy this item.",
            "error.shopNeedMoreTokens"),
    ERROR_SHOP_MAX_SEEKERS_REACHED("%TAG%ESorry, the maximum amount of seekers has been reached!",
            "error.shopMaxSeekersReached"),
    ERROR_SHOP_MAX_HIDERS_REACHED("%TAG%ESorry, the maximum amount of hiders has been reached!",
            "error.shopMaxHidersReached"),
    ERROR_TELEPORT_FAILED("%TAG%EUnable to teleport you into the arena.", "error.teleportFailed"),
    ERROR_TELEPORT_BLOCKED("%TAG%EYou cannot teleport while playing!", "error.teleportBlocked"),
    ;

    private final Object defaultValue;
    private final ConfigManager config = MemoryStorage.messages;
    private final String location;

    /**
     * Instantiates a new config key
     *
     * @param configManager <p>Setting in the config file.</p>
     * @param path          <p>The path of this value in the configuration file</p>
     */
    MessageKey(Object configManager, String path) {
        this.defaultValue = configManager;
        this.location = path;
    }

    @Override
    public String getPath() {
        return this.location;
    }

    @Override
    public ConfigManager getConfigManager() {
        return this.config;
    }

    @Override
    public Object getDefaultValue() {
        return defaultValue;
    }

}
