package net.knarcraft.blockhunt.config;

public enum Permission {

    INFO("info", PermissionDefault.ALL),
    HELP("help", PermissionDefault.ALL),
    RELOAD("reload", PermissionDefault.ADMIN),
    JOIN("join", PermissionDefault.PLAYER),
    JOIN_FULL("joinfull", PermissionDefault.MODERATOR),
    JOIN_SIGN("joinsign", PermissionDefault.PLAYER),
    LEAVE("leave", PermissionDefault.PLAYER),
    LIST("list", PermissionDefault.PLAYER),
    SHOP("shop", PermissionDefault.PLAYER),
    SHOP_BLOCK_CHOOSER("shop.blockchooser", PermissionDefault.ADMIN),
    START("start", PermissionDefault.MODERATOR),
    CREATE("create", PermissionDefault.ADMIN),
    SET("set", PermissionDefault.MODERATOR),
    SET_WARP("setWarp", PermissionDefault.MODERATOR),
    SIGN_CREATE("signcreate", PermissionDefault.MODERATOR),
    REMOVE("remove", PermissionDefault.ADMIN),
    TOKENS("tokens", PermissionDefault.ADMIN),
    ALL_COMMANDS("allcommands", PermissionDefault.OP);

    public final String perm;
    public final PermissionDefault type;

    Permission(String perm, PermissionDefault type) {
        this.perm = perm;
        this.type = type;
    }

}
