package net.knarcraft.blockhunt.listener;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.SignsHandler;
import net.knarcraft.blockhunt.config.Permission;
import net.knarcraft.blockhunt.manager.PermissionsManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.SignChangeEvent;

public class OnSignChangeEvent implements Listener {

    @EventHandler(priority = EventPriority.NORMAL, ignoreCancelled = true)
    public void onSignChangeEvent(SignChangeEvent event) {
        Player player = event.getPlayer();
        String[] lines = event.getLines();
        if (lines[0] != null) {
            if (lines[0].equalsIgnoreCase("[" + BlockHunt.getPluginDescriptionFile().getName() + "]")) {
                if (PermissionsManager.hasPerm(player, Permission.SIGN_CREATE, true)) {
                    SignsHandler.createSign(event, lines, event.getBlock().getLocation());
                }
            }
        }
    }
}
